<?php
header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');
$method = $_SERVER['REQUEST_METHOD'];

if ($method === 'OPTIONS') {
    header('Access-Control-Allow-Methods: GET, POST, PUT, DELETE');
    header('Access-Control-Allow-Headers: Origin, Accept, Content-Type, X-Requested-With');
    exit();
}

include_once '../../config/Database.php';
include_once '../../models/Author.php';

$database = new Database();
$db = $database->connect();


if (isset($_GET['id'])) {
    $id = $_GET['id'];
    echo getAuthorsById($db, $id);
} else {
    echo getAuthors($db);
}

function getAuthors($db) {
    $author = new Author($db);

    $stmt = $author->read();
    $num = $stmt->rowCount();

    if ($num > 0) {
        $authors_arr = array();

        while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
            extract($row);
            $author_item = array(
                "id" => $id,
                "author" => $author
            );

            array_push($authors_arr, $author_item);
        }

        return json_encode($authors_arr);
    } else {
        return json_encode(array("message" => 'author_id Not Found'));
    }
}

function getAuthorsById($db, $id) {
    $author = new Author($db);

    $stmt = $author->readSingle($id);

    $num = $stmt->rowCount();

    if ($num > 0) {

        while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
            extract($row);
            $author_item = array(
                "id" => $id,
                "author" => $author
            );

        }

        return json_encode($author_item);
    } else {
        return json_encode(array("message" => 'author_id Not Found'));
    }
}