<?php
header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');
$method = $_SERVER['REQUEST_METHOD'];

if ($method === 'OPTIONS') {
    header('Access-Control-Allow-Methods: GET, POST, PUT, DELETE');
    header('Access-Control-Allow-Headers: Origin, Accept, Content-Type, X-Requested-With');
    exit();
}

include_once '../../config/Database.php';
include_once '../../models/Categories.php';

$database = new Database();
$db = $database->connect();

if (isset($_GET['id'])) {
    $id = $_GET['id'];
    echo getCategoryById($db, $id);
} else {
    echo getCategories($db);
}

function getCategories($db) {
    $category = new Category($db);

    $stmt = $category->read();
    $num = $stmt->rowCount();

    if ($num > 0) {
        $categories_arr = array();

        while ($row = $stmt->fetch(PDO::FETCH_ASSOC)) {
            extract($row);
            $category_item = array(
                "id" => $id,
                "category" => $category
            );

            array_push($categories_arr, $category_item);
        }

        return json_encode($categories_arr);
    } else {
        return json_encode(array("message" => "category_id Not Found"));
    }
}

function getCategoryById($db, $id) {
    $category = new Category($db);

    $category->id = $id;
    $category->readSingle();

    if($category->category != null){
        $category_arr = array(
            "id" =>  $category->id,
            "category" => $category->category
        );

        return json_encode($category_arr);
    } else {
        return json_encode(array("message" => "category_id Not Found"));
    }
}
